"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
var Rx_1 = require("rxjs/Rx");
var setting_1 = require("../setting");
var AppConfig = (function () {
    function AppConfig(http) {
        this.http = http;
        this.paths = [];
        this.config = [];
        this.env = null;
        this.subject = new Rx_1.Subject();
        this.initialized = this.subject.asObservable();
    }
    AppConfig.prototype.getPresentationConfigs = function () {
        return this.config.filter(function (x) { return x.key.toLowerCase().endsWith("config"); });
    };
    AppConfig.prototype.get = function (key) {
        var setting = this.config.filter(function (x) { return x.key.toLowerCase() == key.toLowerCase(); });
        return setting.length > 0 ? setting[0].value : null;
    };
    AppConfig.prototype.getEnv = function (key) {
        return this.env[key];
    };
    AppConfig.prototype.addNavigationItems = function (applicationName, paths) {
        var _loop_1 = function (path) {
            if (this_1.paths.filter(function (x) { return x.value.name == path.name; }).length == 0) {
                this_1.paths.push(new setting_1.Setting(applicationName, { name: path.name, route: path.route }));
            }
        };
        var this_1 = this;
        for (var _i = 0, paths_1 = paths; _i < paths_1.length; _i++) {
            var path = paths_1[_i];
            _loop_1(path);
        }
    };
    AppConfig.prototype.fetchNavigationItems = function (applicationName) {
        return this.paths.filter(function (x) { return x.key === applicationName; }).map(function (x) { return new setting_1.Setting(x.value.name, x.value.route); });
    };
    AppConfig.prototype.initialize = function (settings, env) {
        this.config = this.config.concat(settings);
        this.env = env;
        this.subject.next(true);
    };
    return AppConfig;
}());
AppConfig = __decorate([
    core_1.Injectable(),
    __metadata("design:paramtypes", [http_1.Http])
], AppConfig);
exports.AppConfig = AppConfig;
//# sourceMappingURL=app.config.js.map